                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 8: lexical addressing   */
                     /*-----------------------------------*/
                     /*              threads              */
                     /*-----------------------------------*/

#include "SlipMain.h"
#include "SlipThread.h"

/*------------------------------ private variables ---------------------------*/

static CNT_type Current_thread;

/*------------------------------ public functions ----------------------------*/

NIL_type Thread_Initialize(NIL_type)
  { Current_thread = Main_Empty_Continuation; }

CNT_type Thread_Keep(NIL_type)
  { return Current_thread; }

CNT_type Thread_Peek(NIL_type)
  { return Current_thread; }

CNT_type Thread_Poke(CFN_type C_function,
                     UNS_type Size)
  { CNT_type continuation;
    continuation = Current_thread->cnt; 
    Current_thread = make_CNT(C_function,
                              continuation,
                              Size);
    return Current_thread; }
    
CNT_type Thread_Patch(CFN_type C_function)
  { Current_thread->cfn = C_function; 
    return Current_thread; }

CNT_type Thread_Pop(NIL_type)
  { CNT_type continuation;
    continuation = Current_thread;
    Current_thread = Current_thread->cnt; 
    return continuation; }

CNT_type Thread_Push(CFN_type C_function,
                     UNS_type Size)
  { CNT_type continuation;
    continuation = make_CNT(C_function,
                            Current_thread,
                            Size);
    Current_thread = continuation; 
    return continuation; }
    
NIL_type Thread_Zap(NIL_type)
  { Current_thread = Current_thread->cnt; }

